Download it now!
Bug 128468 - No ruler and therefore no easy way to add/edit/remove tab stops in writer on iOS
Summary: No ruler and therefore no easy way to add/edit/remove tab stops in writer on iOS
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: iOS Editor (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other iOS
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:6.5.0 target:7.0.0
Keywords:
Depends on:
Blocks:
 
Reported: 2019-10-29 16:36 UTC by Nicolas Christener
Modified: 2020-11-20 09:53 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
Ruler in desktop LibreOffice (53.55 KB, image/png)
2019-12-03 09:48 UTC, Tor Lillqvist
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Nicolas Christener 2019-10-29 16:36:09 UTC
Description:
Writer on iOS doesn't show the ruler and it's therefore not easy to add/edit/remove tab stops (it's possible to do so through tunneled dialogs but users expect to be able to add/edit/remove tab stops through the ruler).

Steps to Reproduce:
1. Create/open a writer document in the iOS app
2. Try to add/edit/remove a tap stop with the finger (through e.g. a ruler)

Actual Results:
There is no ruler visible and therefore there is no easy way to add/edit/remove tab stops.

Expected Results:
It should be able to add/edit/remove tab stops with a finger.


Reproducible: Always


User Profile Reset: No



Additional Info:
Comment 1 Xisco Faulí 2019-10-30 08:26:32 UTC
Moving to NEW
Comment 2 Tor Lillqvist 2019-11-29 08:31:36 UTC
Ah, only now I noticed that there is a bug report for the ruler thing, too. Sadly I thus haven't referenced this bug in the commit messages.

Even getting the already implemented functionality in the ruler to actually work satisfactorily was quite a chore. (The ruler was hidden on mobile devices, presumably exactly because we had noticed how bad it worked.)

In version 4.1.72(72) of the iOS app, now available in TestFlight, it is now better: The ruler shows up (on iPad), and one can move the margin indicators in the ruler (and the document margins are actually adjusted accordingly), and the ruler is kept up-to-date when the document is panned and zoomed. (Some small glitches still remain.) Now I can start adding the new functionality that is requested, i.e. tab stops.

Also, the usability of the ruler on touch devices could need some improvements, it is a bit hard to put your finger in exactly the right spot to drag the margins.
Comment 3 Tor Lillqvist 2019-11-29 13:22:05 UTC
Except that now I find it extremely hard to drag the margins even in the app built from the 4.1.x series. Yesterday it seemed easier, for some unclear reason.
Comment 4 Tor Lillqvist 2019-12-02 10:50:34 UTC
After some more testing, I think I have found how to make the handles work reliably: You need to wait some seconds after the document shows up until you tap the blue round "make-editable" button (which makes the ruler show up). If I wait calmly until the text "Page 1 of 2" (etc) shows up in the bottom status bar, and only then tap the make-editable button, I can drag the ruler margin handles very reliably.

Of course, this is not acceptable, this is not how it should be, but this discovery hopefully gives me a hint what to look for and ideas how to fix the problem.
Comment 5 Tor Lillqvist 2019-12-02 15:01:37 UTC
Yay, https://gerrit.libreoffice.org/#/c/84235/ helps a lot. Now I can finally start working on adding actually new functionality.
Comment 6 Tor Lillqvist 2019-12-03 09:48:34 UTC
Created attachment 156264 [details]
Ruler in desktop LibreOffice

Looking at desktop LibreOffice and the kind of tab stops and other things that appear in the ruler there, which ones are needed in the iOS app? See figure. Presumably we want to simplify it somehow compared to desktop LO.
Comment 7 Commit Notification 2019-12-05 12:52:05 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/891b0c54ead076f0458197233a47d227b1b36f64

tdf#128468: Add Ruler::GetTabs()

It will be available in 6.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 8 Commit Notification 2019-12-05 12:52:12 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/f77fd91dc24b197086df1845735da77fec64ec30

tdf#128468: Add tab stop information to LOK_CALLBACK_RULER_UPDATE

It will be available in 6.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2019-12-05 12:52:23 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/55eddbecb34f811d5292fe4dc5c568cf5fff2ad4

tdf#128468: The RulerTab::nPos is in twips

It will be available in 6.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2019-12-06 13:45:58 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/99a6839cb2b7a4daaa07ad5d629a1f29849cb9fb

tdf#128468: Make the ruler show up in the iOS app on iPad
Comment 11 Commit Notification 2019-12-10 04:46:31 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/7585789456cc5e42d968a483d83cc6248b1f3862

tdf#128468: Make dragging the margins in the ruler work better in iOS app
Comment 12 Commit Notification 2019-12-10 07:33:57 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/e8ee2aa06e654980248e0a7dbb599eb7738f8525

tdf#128468: Make the margin handles in the ruler work better in the iOS app
Comment 13 Commit Notification 2019-12-10 07:35:14 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/f1044b1daea45452e06e8b6213d6c53391253ded

tdf#128468: Get rid of a bunch of pointless variables
Comment 14 Commit Notification 2019-12-10 08:24:19 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/18ac05024001d7117a6f398aae59cd221b408176

tdf#128468: Draw the tab stops
Comment 15 Commit Notification 2019-12-10 08:38:24 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/59900d874c58886916ab0e71f522b1eed5cd60b8

tdf#128468: Tweak the ruler tick and tab stop positions to be just right
Comment 16 Commit Notification 2019-12-10 08:58:41 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/e2e42914a4d026e0af1ec7ac0ba459e4d3048fa2

tdf#128468: Add a clarifying comment
Comment 17 Xisco Faulí 2020-01-20 14:25:24 UTC
A polite ping to Tor Lillqvist:
Is this bug fixed? if so, could you please close it as RESOLVED FIXED ?
Otherwise, Could you please explain what's missing?
Thanks
Comment 18 Tor Lillqvist 2020-01-20 15:03:50 UTC
Not fixed yet, work in progress (waiting for higher priority work to be finished).
Comment 19 Commit Notification 2020-02-03 13:39:02 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/d532705a8594936b71a063b2d9c383bcd63c6b84

tdf#128468: Make dragging the tab stops send a UNO command
Comment 20 Commit Notification 2020-02-04 14:02:19 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/online/commit/15bad57fc9a9dccabca1bdec9760603e7501d3c3

tdf#128468: Do actually pass the Amount parameter of MoveTabstop in twips
Comment 21 Tor Lillqvist 2020-02-05 13:11:14 UTC
With https://gerrit.libreoffice.org/c/core/+/87977 it is now possible to move tab stops. Still missing a way to add them. Need to come up with some sane UI for that. (Just clicking/tapping into the ruler is probably not a good idea, one can do that by accident.) Also, all three types of non-default tab stops (left, middle, right) look the same. And the UI is not entirely as smooth as one would like. But progress...
Comment 22 Nicolas Christener 2020-06-23 12:05:21 UTC
It's possible to add and remove tab stops and it's also possible to change their position in iOS v. 4.2.5 (57).

However the following issues persist:

* Dragging an existing tab stop to a new position results in a "jump" after dragging is finished. E.g dragging a tab stop to 10cm, after dragging finished, the tab stop jumps back to e.g. 7.5

* Changing the tab stop style (right, center, left) seems not to be possible

Should I fill new issues for this?
Comment 23 Nicolas Christener 2020-11-20 06:15:25 UTC
I think we can close this issue.

I created a new issue for the specific problems the implementation now has.

Thanks a lot to the Collabora team and especially Tor for taking care of this!
Comment 24 Aron Budea 2020-11-20 09:53:25 UTC
Let's close, thanks for verifying and for following up, Nicolas!